﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Logging;
using KB2645_IgniteUITagHelperInDNC.Models;

namespace KB2645_IgniteUITagHelperInDNC.Controllers
{
    public class HomeController : Controller
    {
        private readonly ILogger<HomeController> _logger;

        public HomeController(ILogger<HomeController> logger)
        {
            _logger = logger;
        }

        public IActionResult Index()
        {
            return View(GetUsers().AsQueryable());
        }

        private List<User> GetUsers()
        {
            Random rnd = new Random();
            String[] familyNames = { "藤野", "伏見", "牧", "村山", "横井", "金谷", "湊", "木下", "丸山", "熊沢", "中尾", "湯川", "後藤", "乾", "梅木", "矢島", "田上", "岸本", "児島", "西谷" };
            String[] givenNames = { "都", "愛花", "風子", "亜衣", "麗奈", "沙也香", "信二", "猛", "治", "花怜", "里香", "環", "茉莉", "友和", "愛奈", "堂下", "清一", "澄江", "陽保", "範久" };

            List<User> users = new List<User>();
            for(int i = 0; i < 5; i++)
            {
                int familyNameIndex = rnd.Next(familyNames.Length);
                int givenNameIndex = rnd.Next(givenNames.Length);
                int birthDayYear = rnd.Next(1960, 2000);
                int birthDayMonth = rnd.Next(12) + 1;
                int birthDayDay = rnd.Next(25) + 1;

                users.Add(new Models.User() { Id = i, Username = familyNames[familyNameIndex] + " " + givenNames[givenNameIndex], CountryId = "JP", BirthDate = new DateTime(birthDayYear, birthDayMonth, birthDayDay), IsAdmin = (i % 5 == 0) });
            }

            return users;
        }

        public IActionResult Privacy()
        {
            return View();
        }

        [ResponseCache(Duration = 0, Location = ResponseCacheLocation.None, NoStore = true)]
        public IActionResult Error()
        {
            return View(new ErrorViewModel { RequestId = Activity.Current?.Id ?? HttpContext.TraceIdentifier });
        }
    }
}
